(defun c:conv()

(setq value 1)
(setq convert_card (load_dialog "convert.dcl"))
(if (not (new_dialog "convert" convert_card)) (exit))

(start_image "img")
(setq xx (dimx_tile "img"))
(setq yy (dimy_tile "img"))
(slide_image 0 0 xx yy "distance")
(end_image)

(setq in_list_d (list
"Angstroms" "Centimeters" "Fathoms" "Feet" "Furlongs" "Hands" 
"Inches" "Kilometers" "Light_Years" "Meters" "Microns" "Miles"
"Mile_Nautical" "Millimeters" "Parsecs" "Yards"))
(setq out_list_d in_list_d)

(setq in_list_a (list
"Acres" "Barns" "Centares" "Hectares" "Roods" "Townships" "sq.meters"
"sq.feet" "sq.inch" "sq.cms" "sq.mm" "sq.km"))
(setq out_list_a in_list_a)

(setq in_list_an (list
"Circles" "Degrees" "Grads" "Quadrants" "Radians" ))
(setq out_list_an in_list_an)

(setq in_list_t (list
"Centigrade" "Fahrenheit" "Kelvin"))
(setq out_list_t in_list_t)

(setq in_list_ti (list
"Centuries" "Days" "Decades" "Fortnights" "Hours" 
"Millenium" "Minutes" "Weeks" "Years"))
(setq out_list_ti in_list_ti)

(setq in_list_v (list
"Barrels" "CC" "Gallons" "Litres" "Milliliters" "Cubic_meters" 
"Cubic_feet" "Cubic_inches"))
(setq out_list_v in_list_v)

(setq in_list_m (list
"Dynes" "Kilograms" "Ounces" "Pounds" "Tons"))
(setq out_list_m in_list_m)

(action_tile "distance" "(reset) (do_distance)")
(action_tile "area" "(reset) (do_area)")
(action_tile "angle" "(reset) (do_angle)")
(action_tile "temperature" "(reset) (do_temperature)")
(action_tile "time" "(reset) (do_time)")
(action_tile "volume" "(reset) (do_volume)")
(action_tile "mass" "(reset) (do_mass)")

(set_tile "value" (rtos value 2 2))
(action_tile "value" "(setq value (distof $value))")

(action_tile "convert" "(do_convert)")
(action_tile "reset" "(reset)")

(action_tile "accu" "(setq accu (distof $value)) (do_accu $value $reason)")

(action_tile "close" "(clos_e) (setq xyz (done_dialog))")

(action_tile "help" "(setq a$ 2)" )

(do_distance)
(setq what_convert (start_dialog))
(unload_dialog convert_card)

(princ)

) ;; defun conv

;;**************;;**************;;**************;;**************

(defun do_accu(val why)
(if (or (= why 2) (= why 1)) (progn
(setq con$1 (strcat "(cvunit " (rtos value) "\"" ip "\"  \"" op "\")"))
(setq con$2 (read con$1))
(setq con$3 (eval con$2))
(setq result (rtos con$3 2 (fix accu)))
(set_tile "result" " ")
(set_tile "result" result) 
(set_tile "accu_val" (strcat " < " (rtos accu 2 0) " > "))
))
) ;; defun do_accu

;;**************;;**************;;**************;;**************

(defun do_convert()
(if (not accu) (setq accu 4))
(set_tile "accu" (rtos accu 2 0))
(set_tile "accu_val" (strcat " < " (rtos accu 2 0) " >"))
(setq con$1 (strcat "(cvunit " (rtos value) "\"" ip "\"  \"" op "\")"))
(setq con$2 (read con$1))
(setq con$3 (eval con$2))
(setq result (rtos con$3 2 (fix accu)))
(set_tile "result" result) 

)

;;**************;;**************;;**************;;**************

(defun reset()

(set_tile "ip" " ")
(set_tile "op" " ")
(set_tile "result" " ")
(set_tile "value" (rtos 1))
(setq value 1)
(set_tile "accu" "4")
(set_tile "accu_val" " < 4 >")
)

;;**************;;**************;;**************;;**************

(defun clos_e()
(setq accu 4)
) ;; defun clos_e

;;**************;;**************;;**************;;**************

(defun do_set_ip()
(cond 

( (= ip_no 0)  (setq ip "angstroms")     (set_tile "ip" ip)  )
( (= ip_no 1)  (setq ip "centimeters")   (set_tile "ip" ip)  )
( (= ip_no 2)  (setq ip "fathoms")       (set_tile "ip" ip)  )
( (= ip_no 3)  (setq ip "ft")            (set_tile "ip" ip)  )
( (= ip_no 4)  (setq ip "furlongs")      (set_tile "ip" ip)  )
( (= ip_no 5)  (setq ip "hands")         (set_tile "ip" ip)  )
( (= ip_no 6)  (setq ip "inches")        (set_tile "ip" ip)  )
( (= ip_no 7)  (setq ip "kilometers")    (set_tile "ip" ip)  )
( (= ip_no 8)  (setq ip "light_years")   (set_tile "ip" ip)  )
( (= ip_no 9)  (setq ip "meters")        (set_tile "ip" ip)  )
( (= ip_no 10) (setq ip "microns")       (set_tile "ip" ip)  )
( (= ip_no 11) (setq ip "miles")         (set_tile "ip" ip)  )
( (= ip_no 12) (setq ip "mile_nautical") (set_tile "ip" ip)  )
( (= ip_no 13) (setq ip "millimeters")   (set_tile "ip" ip)  )
( (= ip_no 14) (setq ip "parsecs")       (set_tile "ip" ip)  )
( (= ip_no 15) (setq ip "yards")         (set_tile "ip" ip)  )

)
)

(defun do_set_op()

(cond 

( (= op_no 0)  (setq op "angstroms")     (set_tile "op" op)  )
( (= op_no 1)  (setq op "centimeters")   (set_tile "op" op)  )
( (= op_no 2)  (setq op "fathoms")       (set_tile "op" op)  )
( (= op_no 3)  (setq op "ft")            (set_tile "op" op)  )
( (= op_no 4)  (setq op "furlongs")      (set_tile "op" op)  )
( (= op_no 5)  (setq op "hands")         (set_tile "op" op)  )
( (= op_no 6)  (setq op "inches")        (set_tile "op" op)  )
( (= op_no 7)  (setq op "kilometers")    (set_tile "op" op)  )
( (= op_no 8)  (setq op "light_years")   (set_tile "op" op)  )
( (= op_no 9)  (setq op "meters")        (set_tile "op" op)  )
( (= op_no 10) (setq op "microns")       (set_tile "op" op)  )
( (= op_no 11) (setq op "miles")         (set_tile "op" op)  )
( (= op_no 12) (setq op "mile_nautical") (set_tile "op" op)  )
( (= op_no 13) (setq op "millimeters")   (set_tile "op" op)  )
( (= op_no 14) (setq op "parsecs")       (set_tile "op" op)  )
( (= op_no 15) (setq op "yards")         (set_tile "op" op)  )

)
)

(defun do_distance()

(start_list "input_list")
(mapcar 'add_list in_list_d)
(end_list)
(action_tile "input_list" "(setq ip_no (atoi $value)) (do_set_ip)")

(start_list "output_list")
(mapcar 'add_list out_list_d)
(end_list)
(action_tile "output_list" "(setq op_no (atoi $value)) (do_set_op)")

(start_image "img")
(setq xx (dimx_tile "img"))
(setq yy (dimy_tile "img"))
(fill_image 0 0 xx yy -15)
(slide_image 0 0 xx yy "distance")
(end_image)

) ;; defun do _distance

;;*************;;*************;;*************;;*************;;*************

(defun do_set_ip_a()
(cond 

( (= ip_no_a 0)  (setq ip "acres")     (set_tile "ip" ip)  )
( (= ip_no_a 1)  (setq ip "barns")     (set_tile "ip" ip)  )
( (= ip_no_a 2)  (setq ip "centares")  (set_tile "ip" ip)  )
( (= ip_no_a 3)  (setq ip "hectares")  (set_tile "ip" ip)  )
( (= ip_no_a 4)  (setq ip "roods")     (set_tile "ip" ip)  )
( (= ip_no_a 5)  (setq ip "townships") (set_tile "ip" ip)  )

( (= ip_no_a 6)  (setq ip "meter^2")      (set_tile "ip" ip)   )
( (= ip_no_a 7)  (setq ip "feet^2")       (set_tile "ip" ip)   )
( (= ip_no_a 8)  (setq ip "inch^2")       (set_tile "ip" ip)   )
( (= ip_no_a 9)  (setq ip "centimeter^2") (set_tile "ip" ip)   )
( (= ip_no_a 10) (setq ip "millimeter^2") (set_tile "ip" ip)   )
( (= ip_no_a 11) (setq ip "kilometer^2")   (set_tile "ip" ip)  )
)
)

(defun do_set_op_a()
(cond

( (= op_no_a 0)  (setq op "acres")     (set_tile "op" op)  )
( (= op_no_a 1)  (setq op "barns")     (set_tile "op" op)  )
( (= op_no_a 2)  (setq op "centares")  (set_tile "op" op)  )
( (= op_no_a 3)  (setq op "hectares")  (set_tile "op" op)  )
( (= op_no_a 4)  (setq op "roods")     (set_tile "op" op)  )
( (= op_no_a 5)  (setq op "townships") (set_tile "op" op)  )

( (= op_no_a 6)  (setq op "meter^2")       (set_tile "op" op)  )
( (= op_no_a 7)  (setq op "feet^2")        (set_tile "op" op)  )
( (= op_no_a 8)  (setq op "inch^2")        (set_tile "op" op)  )
( (= op_no_a 9)  (setq op "centimeter^2")  (set_tile "op" op)  )
( (= op_no_a 10) (setq op "millimeter^2") (set_tile "op" op)   )
( (= op_no_a 11) (setq op "kilometer^2")  (set_tile "op" op)   )
)
)

(defun do_area()

(start_list "input_list")
(mapcar 'add_list in_list_a)
(end_list)
(action_tile "input_list" "(setq ip_no_a (atoi $value)) (do_set_ip_a)")

(start_list "output_list")
(mapcar 'add_list out_list_a)
(end_list)
(action_tile "output_list" "(setq op_no_a (atoi $value)) (do_set_op_a)")

(start_image "img")
(setq xx (dimx_tile "img"))
(setq yy (dimy_tile "img"))
(fill_image 0 0 xx yy -15)
(slide_image 0 0 xx yy "area")
(end_image)

)


;;*************;;*************;;*************;;*************;;*************

(defun do_set_ip_an()
(cond 

( (= ip_no_an 0)  (setq ip "circles")   (set_tile "ip" ip)  )
( (= ip_no_an 1)  (setq ip "degrees")   (set_tile "ip" ip)  )
( (= ip_no_an 2)  (setq ip "grads")     (set_tile "ip" ip)  )
( (= ip_no_an 3)  (setq ip "quadrants") (set_tile "ip" ip)  )
( (= ip_no_an 4)  (setq ip "radians")   (set_tile "ip" ip)  )

)
)

(defun do_set_op_an()
(cond 

( (= op_no_an 0)  (setq op "circles")   (set_tile "op" op)  )
( (= op_no_an 1)  (setq op "degrees")   (set_tile "op" op)  )
( (= op_no_an 2)  (setq op "grads")     (set_tile "op" op)  )
( (= op_no_an 3)  (setq op "quadrants") (set_tile "op" op)  )
( (= op_no_an 4)  (setq op "radians")   (set_tile "op" op)  )

)
)

(defun do_angle()

(start_list "input_list")
(mapcar 'add_list in_list_an)
(end_list)
(action_tile "input_list" "(setq ip_no_an (atoi $value)) (do_set_ip_an)")

(start_list "output_list")
(mapcar 'add_list out_list_an)
(end_list)
(action_tile "output_list" "(setq op_no_an (atoi $value)) (do_set_op_an)")

(start_image "img")
(setq xx (dimx_tile "img"))
(setq yy (dimy_tile "img"))
(fill_image 0 0 xx yy -15)
(slide_image 0 0 xx yy "angle")
(end_image)

)

;;*************;;*************;;*************;;*************;;*************

(defun do_set_ip_t()
(cond 

( (= ip_no_t 0)  (setq ip "centigrade")  (set_tile "ip" ip)  )
( (= ip_no_t 1)  (setq ip "fahrenheit")  (set_tile "ip" ip)  )
( (= ip_no_t 2)  (setq ip "kelvin")      (set_tile "ip" ip)  )

)
)

(defun do_set_op_t()
(cond 

( (= op_no_t 0)  (setq op "centigrade")  (set_tile "op" op)  )
( (= op_no_t 1)  (setq op "fahrenheit")  (set_tile "op" op)  )
( (= op_no_t 2)  (setq op "kelvin")      (set_tile "op" op)  )

)
)

(defun do_temperature()

(start_list "input_list")
(mapcar 'add_list in_list_t)
(end_list)
(action_tile "input_list" "(setq ip_no_t (atoi $value)) (do_set_ip_t)")

(start_list "output_list")
(mapcar 'add_list out_list_t)
(end_list)
(action_tile "output_list" "(setq op_no_t (atoi $value)) (do_set_op_t)")

(start_image "img")
(setq xx (dimx_tile "img"))
(setq yy (dimy_tile "img"))
(fill_image 0 0 xx yy -15)
(slide_image 0 0 xx yy "temp")
(end_image)


) ;; defun do_temperature

;;*************;;*************;;*************;;*************;;*************

(defun do_set_ip_ti()
(cond 

( (= ip_no_ti 0)  (setq ip "centuries")  (set_tile "ip" ip)  )
( (= ip_no_ti 1)  (setq ip "days")       (set_tile "ip" ip)  )
( (= ip_no_ti 2)  (setq ip "decades")    (set_tile "ip" ip)  )
( (= ip_no_ti 3)  (setq ip "fortnights") (set_tile "ip" ip)  )
( (= ip_no_ti 4)  (setq ip "hours")      (set_tile "ip" ip)  )
( (= ip_no_ti 5)  (setq ip "millenium")  (set_tile "ip" ip)  )
( (= ip_no_ti 6)  (setq ip "minutes")    (set_tile "ip" ip)  )
( (= ip_no_ti 7)  (setq ip "weeks")      (set_tile "ip" ip)  )
( (= ip_no_ti 8)  (setq ip "years")      (set_tile "ip" ip)  )


)
)

(defun do_set_op_ti()
(cond 

( (= op_no_ti 0)  (setq op "centuries")  (set_tile "op" op)  )
( (= op_no_ti 1)  (setq op "days")       (set_tile "op" op)  )
( (= op_no_ti 2)  (setq op "decades")    (set_tile "op" op)  )
( (= op_no_ti 3)  (setq op "fortnights") (set_tile "op" op)  )
( (= op_no_ti 4)  (setq op "hours")      (set_tile "op" op)  )
( (= op_no_ti 5)  (setq op "millenium")  (set_tile "op" op)  )
( (= op_no_ti 6)  (setq op "minutes")    (set_tile "op" op)  )
( (= op_no_ti 7)  (setq op "weeks")      (set_tile "op" op)  )
( (= op_no_ti 8)  (setq op "years")      (set_tile "op" op)  )

)
)

(defun do_time()

(start_list "input_list")
(mapcar 'add_list in_list_ti)
(end_list)
(action_tile "input_list" "(setq ip_no_ti (atoi $value)) (do_set_ip_ti)")

(start_list "output_list")
(mapcar 'add_list out_list_ti)
(end_list)
(action_tile "output_list" "(setq op_no_ti (atoi $value)) (do_set_op_ti)")

(start_image "img")
(setq xx (dimx_tile "img"))
(setq yy (dimy_tile "img"))
(fill_image 0 0 xx yy -15)
(slide_image 0 0 xx yy "time")
(end_image)

) ;; defun do_time

;;*************;;*************;;*************;;*************;;*************

(defun do_set_ip_v()
(cond 

( (= ip_no_v 0)  (setq ip "barrels")     (set_tile "ip" ip)  )
( (= ip_no_v 1)  (setq ip "cc")          (set_tile "ip" ip)  )
( (= ip_no_v 2)  (setq ip "gallons")     (set_tile "ip" ip)  )
( (= ip_no_v 3)  (setq ip "liters")      (set_tile "ip" ip)  )
( (= ip_no_v 4)  (setq ip "milliliters") (set_tile "ip" ip)  )
( (= ip_no_v 5)  (setq ip "meter^3")     (set_tile "ip" ip)  )
( (= ip_no_v 6)  (setq ip "feet^3")      (set_tile "ip" ip)  )
( (= ip_no_v 7)  (setq ip "inch^3")      (set_tile "ip" ip)  )

)
)

(defun do_set_op_v()
(cond 

( (= op_no_v 0)  (setq op "barrels")      (set_tile "op" op)  )
( (= op_no_v 1)  (setq op "cc")           (set_tile "op" op)  )
( (= op_no_v 2)  (setq op "gallons")      (set_tile "op" op)  )
( (= op_no_v 3)  (setq op "liters")       (set_tile "op" op)  )
( (= op_no_v 4)  (setq op "milliliters")  (set_tile "op" op)  )
( (= op_no_v 5)  (setq op "meter^3")     (set_tile "op" op)  )
( (= op_no_v 6)  (setq op "feet^3")      (set_tile "op" op)  )
( (= op_no_v 7)  (setq op "inch^3")      (set_tile "op" op)  )

)
)

(defun do_volume()

(start_list "input_list")
(mapcar 'add_list in_list_v)
(end_list)
(action_tile "input_list" "(setq ip_no_v (atoi $value)) (do_set_ip_v)")

(start_list "output_list")
(mapcar 'add_list out_list_v)
(end_list)
(action_tile "output_list" "(setq op_no_v (atoi $value)) (do_set_op_v)")

(start_image "img")
(setq xx (dimx_tile "img"))
(setq yy (dimy_tile "img"))
(fill_image 0 0 xx yy -15)
(slide_image 0 0 xx yy "volume")
(end_image)


) ;; defun do_volume


;;*************;;*************;;*************;;*************;;*************

(defun do_set_ip_m()
(cond 

( (= ip_no_m 0)  (setq ip "dynes")     (set_tile "ip" ip)  )
( (= ip_no_m 1)  (setq ip "kilograms") (set_tile "ip" ip)  )
( (= ip_no_m 2)  (setq ip "ounces")    (set_tile "ip" ip)  )
( (= ip_no_m 3)  (setq ip "pounds")    (set_tile "ip" ip)  )
( (= ip_no_m 4)  (setq ip "tonnes")      (set_tile "ip" ip)  )

)
)

(defun do_set_op_m()
(cond 

( (= op_no_m 0)  (setq op "dynes")     (set_tile "op" op)  )
( (= op_no_m 1)  (setq op "kilograms") (set_tile "op" op)  )
( (= op_no_m 2)  (setq op "ounces")    (set_tile "op" op)  )
( (= op_no_m 3)  (setq op "pounds")    (set_tile "op" op)  )
( (= op_no_m 4)  (setq op "tonnes")      (set_tile "op" op)  )

)
)

(defun do_mass()

(start_list "input_list")
(mapcar 'add_list in_list_m)
(end_list)
(action_tile "input_list" "(setq ip_no_m (atoi $value)) (do_set_ip_m)")

(start_list "output_list")
(mapcar 'add_list out_list_m)
(end_list)
(action_tile "output_list" "(setq op_no_m (atoi $value)) (do_set_op_m)")

(start_image "img")
(setq xx (dimx_tile "img"))
(setq yy (dimy_tile "img"))
(fill_image 0 0 xx yy -15)
(slide_image 0 0 xx yy "mass")
(end_image)

) ;; defun do_mass

;;*************;;*************;;*************;;*************;;*************

(princ "\nCONVERT.LSP Loaded. Type CONV to execute.") (terpri) (princ)
